<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Quasi-quotation macro that accepts input like the `quote!` macro but uses type inference to figure out a return type for those tokens."><meta name="keywords" content="rust, rustlang, rust-lang, parse_quote"><title>parse_quote in syn - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="sidebar-items.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc macro"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><div class="sidebar-elems"><h2 class="location"><a href="index.html">In syn</a></h2></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../syn/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Macro <a href="index.html">syn</a>::<wbr><a class="macro" href="#">parse_quote</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/syn/parse_quote.rs.html#70-74">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><div class="docblock item-decl"><div class="example-wrap"><pre class="rust macro"><code><span class="macro">macro_rules!</span> <span class="ident">parse_quote</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; { ... };
}</code></pre></div>
</div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Quasi-quotation macro that accepts input like the <a href="https://docs.rs/quote/1.0/quote/index.html"><code>quote!</code></a> macro but uses
type inference to figure out a return type for those tokens.</p>
<p>The return type can be any syntax tree node that implements the <a href="parse/trait.Parse.html"><code>Parse</code></a>
trait.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">quote::quote</span>;
<span class="kw">use</span> <span class="ident">syn</span>::{<span class="ident">parse_quote</span>, <span class="ident">Stmt</span>};

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="kw">let</span> <span class="ident">name</span> <span class="op">=</span> <span class="macro">quote!</span>(<span class="ident">v</span>);
    <span class="kw">let</span> <span class="ident">ty</span> <span class="op">=</span> <span class="macro">quote!</span>(<span class="ident">u8</span>);

    <span class="kw">let</span> <span class="ident">stmt</span>: <span class="ident">Stmt</span> <span class="op">=</span> <span class="macro">parse_quote!</span> {
        <span class="kw">let</span> #<span class="ident">name</span>: #<span class="ident">ty</span> <span class="op">=</span> <span class="ident">Default::default</span>();
    };

    <span class="macro">println!</span>(<span class="string">&quot;{:#?}&quot;</span>, <span class="ident">stmt</span>);
}</code></pre></div>
<p><em>This macro is available only if Syn is built with the <code>&quot;parsing&quot;</code> feature,
although interpolation of syntax tree nodes into the quoted tokens is only
supported if Syn is built with the <code>&quot;printing&quot;</code> feature as well.</em></p>
<h2 id="example"><a href="#example">Example</a></h2>
<p>The following helper function adds a bound <code>T: HeapSize</code> to every type
parameter <code>T</code> in the input generics.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">syn</span>::{<span class="ident">parse_quote</span>, <span class="ident">Generics</span>, <span class="ident">GenericParam</span>};

<span class="comment">// Add a bound `T: HeapSize` to every type parameter T.</span>
<span class="kw">fn</span> <span class="ident">add_trait_bounds</span>(<span class="kw-2">mut</span> <span class="ident">generics</span>: <span class="ident">Generics</span>) -&gt; <span class="ident">Generics</span> {
    <span class="kw">for</span> <span class="ident">param</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">generics</span>.<span class="ident">params</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">GenericParam::Type</span>(<span class="ident">type_param</span>) <span class="op">=</span> <span class="ident">param</span> {
            <span class="ident">type_param</span>.<span class="ident">bounds</span>.<span class="ident">push</span>(<span class="macro">parse_quote!</span>(<span class="ident">HeapSize</span>));
        }
    }
    <span class="ident">generics</span>
}</code></pre></div>
<h2 id="special-cases"><a href="#special-cases">Special cases</a></h2>
<p>This macro can parse the following additional types as a special case even
though they do not implement the <code>Parse</code> trait.</p>
<ul>
<li><a href="struct.Attribute.html" title="Attribute"><code>Attribute</code></a> — parses one attribute, allowing either outer like <code>#[...]</code>
or inner like <code>#![...]</code></li>
<li><a href="punctuated/struct.Punctuated.html" title="Punctuated&lt;T, P&gt;"><code>Punctuated&lt;T, P&gt;</code></a> — parses zero or more <code>T</code> separated by punctuation
<code>P</code> with optional trailing punctuation</li>
<li><a href="struct.Block.html#method.parse_within"><code>Vec&lt;Stmt&gt;</code></a> — parses the same as <code>Block::parse_within</code></li>
</ul>
<h2 id="panics"><a href="#panics">Panics</a></h2>
<p>Panics if the tokens fail to parse as the expected syntax tree type. The
caller is responsible for ensuring that the input tokens are syntactically
valid.</p>
</div></details></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="syn" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>